Subject: [Detnet-dp-dt] Draft update in github

From: Jouni Korhonen <[email-masked]>
Date: Thu, 9 Mar 2017 20:55:29 -0800

Folks,

I did quite a bit of updates to the draft. All in GitHub. I’ll continue writing over the weekend etc..

- Jouni

-- 
Jouni Korhonen, Broadcom, Core Switching Group
+1-408-391-7160

---

From: Loa Andersson <[email-masked]>
Date: Fri, 10 Mar 2017 13:58:33 +0800

Jouni,

I was working on reviewing the previous version, I see that
you captured most of (very close to sll<9 of the comments I had.

Questions:

1. IETF is mostly doing "on the wire" specifications, what is in the
box is mostly viewed as implementation specific. Against this background
why do we need "local-ID", isn't that implementation specific?

2. There are two sentences "In the context of this document DA-T-PE is
referred as T-PE." and "In the context of this document DA-S-PE is 
referred as S-PE." Wouldn't it be better to actually use the new
abbreviations, DA-T-PE and DA-S-PE?

3. Then I wonder if you got what is optional in the label stack
and what is not; what needs to be there is one single tunnel, we have
called that L-labels (PW architecture call it PSN Tunnel) all the rest
of the T-Label tunnels are  optional.

I wrote it down like this:

    +-------------------------------+
    |                               |
    |          DetNet Flow          |
    |            Payload            |  n octets
    |                               |
    +-------------------------------+
    |      DetNet Flow Id           |  4 octets
    +-------------------------------+
    |      DetNet Control Word      |  4 octets
    +-------------------------------+
    |          MS-PW Label          |  4 octets
    +-------------------------------+
    |            L-Label            |  4 octets
    +-------------------------------+
    |   (optional) MPLS T-Label(s)  |  n*4 octets (four octets per label)
    +-------------------------------+

DetNet Flow Payload - n octets
DetNet Flow Id      - 4 octets, part of the encapsualtion header,
                       i.e. not in the label stack
DetNet Control Word - 4 octets, the 16 least significant but are a
                       a sequence number.
MS-PW Label         - 4 octets, this label is unchanged between two
                       DA-x-PEs, and at PW set up it is decided if
                       the Native Service Processing includes DetNet
                       FRER or not, the MS-PW Label is swapped at
                       DA-S-PE.
L-Label             - carries the MS-PW Label unchanged from one
                       DA-x-PE to the next
T-Label(s)          - are optional, and strictly not part of the
                       DetNet encapsulation.

I don't want you to change but maybe capture a few bits and pieces
from this.

Then I have one ridiculous concern, the DA-S-PE does not need to 
interface a CE, and does not necessarily sit on a domain border, and is
tthus not necessary a "real" PE. If we ant to keep calling it a PE
(I think we should), we should have some words around this.

/Loa

-- 

Loa Andersson                        email: [email-masked]
Senior MPLS Expert                          [email-masked]
Huawei Technologies (consultant)     phone: +46 739 81 21 64

---

From: Loa Andersson <[email-masked]>
Date: Fri, 10 Mar 2017 14:36:07 +0800

Jouni,

You say:

    Depending on the network topology the "overlay label" may be part of
    the label stack.  This "L-label" has actually nothing specific to do
    with DetNet but can be used to build overlay topologies over the
    provider network in a same way virtual private networks (VPN) are
    built.

What you sday about overlay topoöogies is correct, butthere is one more
characteristic of the L-label it guarantee that the PW-label is
unchanged from DA-x-PE to DA-x-PE, a tunnel that does not
expose the PW-label other than to the DA-S-PE or the DA-T-PE is not
optional, it must be there.

/Loa

--

---

From: Jouni Korhonen <[email-masked]>
Date: Fri, 10 Mar 2017 00:58:03 -0800

Loa,

Correct. I kind of failed to say that :)

- Jouni

> On 09 Mar 2017, at 22:36, Loa Andersson <[email-masked]> wrote:
> 
> Jouni,
> 
> You say:
> 
> _______________________________________________
> Detnet-dp-dt mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/detnet-dp-dt

---

From: Loa Andersson <[email-masked]>
Date: Fri, 10 Mar 2017 19:08:26 +0800

Jouni,

OK - let us know when you upload a new version. The improvements
version by version so far has been great. Did you look at my other
qustions?

/Loa

--

---

From: Balázs Varga A <[email-masked]>
Date: Fri, 10 Mar 2017 12:32:36 +0000

Hi Jouni,

Good progress. 

I have updated the "xml" on GitHub, however all proposed changes are 
commented out. Remove old text and delete comment mark if You are 
fine with the changes. You can find them by looking for "<!--VB"

My comments in addition to Loa's ones:
- Terminology section (PW Label): text was somewhat misleading. I have 
changed it to " A PseudoWire label that is used to identify DetNet flow 
related PW Instances within a PE node. "

- Figure 2.: Text refers to "X" on figure as replication and elimination point. 
I have found somewhat confusing to have 2 pieces of "X" in x-PE nodes
for the highlighted DetNet flow. I have modified the figure to have 
single "X" per x-PE node.

- paragraph above Figure3: some editorial changes + deleted L3VPN example 
in the last sentence, as legacy L3VPNs would not allow "X" points e.g., on S-PE2.

- Figure 3.: here we have double XX in S-PE2 node. Changed as in Figure2.

- Figure 8/9.: in figure 2/3 we have use "X" to denote replication and elimination
points, whereas in figure 8/9 a "*" is used. I have changed these figures to be 
consequent with previous figures.

Cheers
Bala'zs

-----Original Message-----
From: Detnet-dp-dt [mailto:[email-masked]] On Behalf Of Jouni Korhonen
Sent: Friday, March 10, 2017 5:55 AM
To: [email-masked]
Subject: [Detnet-dp-dt] Draft update in github

Folks,

- Jouni

---

From: Jouni Korhonen <[email-masked]>
Date: Fri, 10 Mar 2017 09:24:40 -0800

Balazs,

> On Mar 10, 2017, at 4:32 AM, Balázs Varga A <[email-masked]> wrote:
> 
> Hi Jouni,
> 
> Good progress. 
> 
> fine with the changes. You can find them by looking for "<!—VB"

Thanks.

> related PW Instances within a PE node. “

Much better.

I was also thinking that while most of the text is really only in DetNet context all existing MS-PW functionality is still there. Maybe we should emphasize this somewhere in the introduction that DetNet does not preclude using the same infra for the “traditional” use as well.

> single "X" per x-PE node.

Good point. I changed these.

> in the last sentence, as legacy L3VPNs would not allow "X" points e.g., on S-PE2.

Changed.

> - Figure 3.: here we have double XX in S-PE2 node. Changed as in Figure2.

Changed.

> consequent with previous figures.

Changed.

- Jouni

---

From: János Farkas <[email-masked]>
Date: Fri, 10 Mar 2017 19:01:53 +0100

Hi Jouni,

I've made some changes to the draft. The attached pdf indicates them.
I've updated the xml version where you moved Balazs' text to be main 
text. I hope i did not mess xml versioning.
(the commented pdf is one version earlier)

Well, I did not make any dramatic change.
I'd highlight two:
a) replaced "data plane protocol" with "data plane solution". We are 
working on solution as reflected by "sol" in the file name ;-). I mean, 
a protocol is rather above the data plane, e.g., in the control plane.
b) replaced "domain" with alternatives. DetNet is for single domain. 
Actually, domain is an overloaded term: administrative domain, etc., 
better to avoid.

I highlighted one thing in the pdw, which I did not implement in the xml:
"frame replication and elimination"
The architecture document uses "packet replication and elimination", 
which I think would be better to be used in this doc too; except for he 
cases when we explicitly refer to 802.1CB.
This appears multiple places, another variant: ""frame replication and 
duplicate elimination".
If there is agreement then we could make the change.

Regards,
Janos

---

From: Jouni Korhonen <[email-masked]>
Date: Fri, 10 Mar 2017 12:22:32 -0800

Thanks.

> On Mar 10, 2017, at 10:01 AM, János Farkas <[email-masked]> wrote:
> 
> Hi Jouni,
> 
> I've updated the xml version where you moved Balazs' text to be main text. I hope i did not mess xml versioning.

Nope. I rebased my ongoing edits to yours so everything is fine. Nothing git cannot do ;)

> a) replaced "data plane protocol" with "data plane solution". We are working on solution as reflected by "sol" in the file name ;-). I mean, a protocol is rather above the data plane, e.g., in the control plane.
> b) replaced "domain" with alternatives. DetNet is for single domain. Actually, domain is an overloaded term: administrative domain, etc., better to avoid.

Ack.

> The architecture document uses "packet replication and elimination", which I think would be better to be used in this doc too; except for he cases when we explicitly refer to 802.1CB.
> This appears multiple places, another variant: ""frame replication and duplicate elimination".

Let’s go for the arch doc way. So “Packet Replication and Elimination for Redundancy” (PREF) ?

- Jouni

> <draft-dt-detnet-dp-sol-00 - 2017-03-10-JF-comments.pdf>

---

From: Loa Andersson <[email-masked]>
Date: Sat, 11 Mar 2017 13:59:44 +0800

Jouni,

Nit picking

LSR stands for Label Switching Router
                            ^^^

In the terminology section and section 4.2.

I think PREF and FREF should go into terminology section.

/Loa

--

---

From: Carlos Jesús Bernardos Cano <[email-masked]>
Date: Sat, 11 Mar 2017 13:32:50 +0100

Hi János,

Just one comment about "domain" below. 

> Actually, domain is an overloaded term: administrative domain, etc., 

I agree with you. I made some editorial changes before to align with
the draft-ietf-detnet-architecture document, where "DetNet domain" is
used. But I've checked again and it's true that domain is merely used
in the terminology section and not really in the text. Norm, maybe you
can consider removing "DetNet domain" from the arch document
(terminology section) so both docs are consistent.

I'm reviewing the draft. I'll soon send some updates (I expect them to
be just minor things/editorial).

Thanks,

Carlos

---

From: Jiangyuanlong <[email-masked]>
Date: Sat, 11 Mar 2017 12:35:10 +0000

"Packet Replication and Elimination for Redundancy" (PRER) , it seems PRER makes more sense in MPLS than FRER.

Cheers,
Yuanlong

-----Original Message-----
From: Detnet-dp-dt [mailto:[email-masked]] On Behalf Of Jouni Korhonen
Sent: Saturday, March 11, 2017 4:23 AM
To: Janos Farkas
Cc: [email-masked]
Subject: Re: [Detnet-dp-dt] Draft update in github

Thanks.

Ack.

- Jouni

---

From: Lou Berger <[email-masked]>
Date: Sat, 11 Mar 2017 07:48:40 -0500

I think you mean from the PW perspective. From the MPLS and provider 
transport perspective, it's  1+1 protection...

On March 11, 2017 7:36:02 AM Jiangyuanlong <[email-masked]> wrote:

>> working on solution as reflected by "sol" in the file name ;-). I mean, a 
>> protocol is rather above the data plane, e.g., in the control plane.
>> Actually, domain is an overloaded term: administrative domain, etc., better 
>> to avoid.
>
> Ack.
>
>> The architecture document uses "packet replication and elimination", which 
>> I think would be better to be used in this doc too; except for he cases 
>> when we explicitly refer to 802.1CB.

---

From: Carlos Jesús Bernardos Cano <[email-masked]>
Date: Sat, 11 Mar 2017 15:49:31 +0100

Hi,

I've just committed some changes, mostly editorial, though I've also
added a couple of comments in the xml (you can look for "<!-- CJBC:" to
easily find them). One refers to Figures 2 & 3: there we have DF1, DF2,
DF3 and DF4, but aren't we referring to the same flow there (being
replicated and merged)?

Thanks,

Carlos

---

From: Carlos Jesús Bernardos Cano <[email-masked]>
Date: Sat, 11 Mar 2017 15:49:35 +0100

Hi,

> abbreviations, DA-T-PE and DA-S-PE?

I agree with this. I've just committed a new version that (except for
the appendixes) only uses DA-*-PE. I've reworked the figures.

Carlos

---

From: Jouni Korhonen <[email-masked]>
Date: Sat, 11 Mar 2017 11:26:18 -0800

Thanks. Will update.

- Jouni

> On Mar 10, 2017, at 9:59 PM, Loa Andersson <[email-masked]> wrote:
> 
> Jouni,
> 
> Nit picking
>

---

From: Jouni Korhonen <[email-masked]>
Date: Sat, 11 Mar 2017 11:30:50 -0800

I think I changed domains to networks in places Janos pointed out.. I might have missed few, though.

- Jouni

> On Mar 11, 2017, at 4:32 AM, Carlos Jesús Bernardos Cano <[email-masked]> wrote:
> 
> Hi János,
>

---

From: Jouni Korhonen <[email-masked]>
Date: Sat, 11 Mar 2017 11:35:00 -0800

FREF has been now replaced by PREF in the document.

- Jouni

> On Mar 11, 2017, at 4:35 AM, Jiangyuanlong <[email-masked]> wrote:
>

---

From: Jouni Korhonen <[email-masked]>
Date: Sat, 11 Mar 2017 12:23:31 -0800

Carlos, Loa,

> On Mar 11, 2017, at 6:49 AM, Carlos Jesús Bernardos Cano <[email-masked]> wrote:
> 
> Hi,
> 

I was thinking more like giving an example of a possible implementation. I got the feeling that if we say nothing about the local-ID folks will start asking how this is going to work.. In that sense the flow-ID as-is “safer” because it is also on-wire.

> the appendixes) only uses DA-*-PE. I've reworked the figures.

Yes. Agree as well. I tried to follow the new naming at least in the new text. Some old text probably has wrong terminology in places.

>> I wrote it down like this:

So far we had the assumption that L-label also remains unchanged between the endpoints the tunnel is set up.. like from T-PE to S-PE. Does this still hold?

The reason why I still keep L-labels around is that it allows easily configure some S-PEs as a pass through.

- Jouni

>> (I think we should), we should have some words around this.

I think we should be covered by MS-PW (RFC6073) description of S-PE.

- Jouni

---

From: János Farkas <[email-masked]>
Date: Sun, 12 Mar 2017 21:26:48 +0100

Hi Jouni,

Well, it is just " Packet Replication and Elimination":
https://tools.ietf.org/html/draft-ietf-detnet-architecture-00#section-3.4

Well, PRE as acronym may be strange.

If we want to copy the logic of 802.1CM title, then it'd be:
Packet Replication and Elimination for Reliability (PRER)

In any case, I think the key is to use packet instead of frame.

Thanks,
Janos

---

From: Jouni Korhonen <[email-masked]>
Date: Sun, 12 Mar 2017 15:54:09 -0700

I see I wrote into the terminology PRER.. later in the text I use PREF (i.e., packet replication and elimination function). I actually prefer the latter since in most cases it fits imho best to the context. I’ll figure out some alignment..

I think you meant 802.1CB and not 802.1CM ;)

- Jouni

> On Mar 12, 2017, at 1:26 PM, János Farkas <[email-masked]> wrote:
> 
> Hi Jouni,
>

---

From: János Farkas <[email-masked]>
Date: Mon, 13 Mar 2017 00:43:48 +0100

> I see I wrote into the terminology PRER.. later in the text I use PREF (i.e., packet replication and elimination function). I actually prefer the latter since in most cases it fits imho best to the…
Either one is fine with me.
Thanks for the clarifications!

> I think you meant 802.1CB and not 802.1CM ;)
Sure, correct.
Thanks,
Janos

---

From: Jouni Korhonen <[email-masked]>
Date: Sun, 12 Mar 2017 16:45:38 -0700

I aligned the text to PREF.. but I am free to change it to anything the majority thinks is the best.

> On Mar 12, 2017, at 4:43 PM, János Farkas <[email-masked]> wrote:
> 
> 
>

---

From: János Farkas <[email-masked]>
Date: Wed, 15 Mar 2017 00:13:17 +0100

Hi Carlos,

Sorry for the late response; it is a mess due to the 802 Plenary.
We discussed "domain" while updating the architecture draft. DetNet is 
chartered for single administrative domain; furthermore, domain is a bit 
overloaded term. That's why it is better to avoid it as much as possible.

Thanks,
Janos

---

From: Carlos Jesús Bernardos Cano <[email-masked]>
Date: Wed, 15 Mar 2017 00:55:15 +0100

Thanks János, I understand. I agree with you (and just mentioned that I
think it'd be good to remove the term also from the detnet architecture
document to be more consistent).

Thanks,

Carlos

On Wed, 2017-03-15 at 00:13 +0100, János Farkas wrote:
> > > I highlighted one thing in the pdw, which I did not implement in
> > > the
> > > xml:
> > > which I think would be better to be used in this doc too; except
> > > for
> > > he
> > > This appears multiple places, another variant: ""frame
> > > replication
> > > and
> > > duplicate elimination".